Unit sfg8e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

function sfg8e(var X :Extended; var IERR :Integer): Extended;

implementation

function sfg8e(var X :Extended; var IERR :Integer): Extended;
var
IX :Integer;
X1,Y,PSI :Extended;
const
ZERO :Real = 0.0e0;
ONE :Real = 1.0e0;
TEN :Real = 10.0e0;
R1 :Real = 0.008333333333333333e0;
R2 :Real = 0.08333333333333333e0;
SYS001 :Real = 3.1415926535897932384626433832795;
SYS039 :Real = 0.57721566490153286060651200000;
SYS053 :Real = 1.7e308;
label
_10,_20,_30,_40,_50;
begin
{ Result -    SFG8E  FORTRANe }
IERR := 0;
X1 := X;
IX := Trunc(X);
PSI := ZERO;
if ( X <> ZERO ) 
 then goto _10;
PSI := -SYS039;
goto _50;
_10:
if ( X > -ONE ) 
 then goto _30;
if ( IX <> X ) 
 then goto _20;
IERR := 65;
PSI := SYS053;
goto _50;
_20:
X := -X-ONE;
PSI := SYS001*Cos(SYS001*X)/Sin(SYS001*X);
_30:
if ( X >= TEN ) 
 then goto _40;
X := X+ONE;
PSI := PSI-ONE/X;
goto _30;
_40:
Y := ONE/(X*X);
PSI := PSI+Ln(X)+0.5e0/X-((Y/252.0e0-R1)*Y+R2)*Y;
_50:
X := X1;
Result := PSI;
exit;
end;

end.
